.segment "HEADER"

	.byte "NES", $1A
	.byte 1
	.byte 1
	.byte 1


.segment "ZEROPAGE"

	Pointer: .res 2
	WaitForNmi: .res 1
	Counter: .res 1

.segment "SPRITES"

	Sprites: .res $100

.segment "CODE"

Reset:

	; Initialization
	SEI
	CLD
	LDX #$40
	STX $4017
	LDX #$FF
	TXS
	INX
	STX $2000
	STX $2001
	STX $4010

	; VBlank 1
	BIT $2002
@waitForVBlank1:
	BIT $2002
	BPL @waitForVBlank1

	; RAM to 0
	TXA
	TAY
	STA Pointer
	STA Pointer + 1
@initializeRamOuterLoop:
@initializeRamInnerLoop:
	LDA #0
	STA (Pointer), Y
	INY
	BNE @initializeRamInnerLoop
	INC Pointer + 1
	INX
	CPX #$08
	BNE @initializeRamOuterLoop

	; VBlank 2
	BIT $2002
@waitForVBlank2:
	BIT $2002
	BPL @waitForVBlank2

	; Sprites out of screen
	LDX #0
	LDA #$F4
@spritesLoop:
	STA Sprites, X
	INX
	BNE @spritesLoop

	; Nine sprites (not sprite 0) in one row
	LDX #4
@nineSpritesLoop:
	LDA #88
	STA Sprites, X
	INX
	LDA #$0F
	STA Sprites, X
	INX
	LDA #0
	STA Sprites, X
	INX
	STA Sprites, X
	INX
	CPX #40
	BNE @nineSpritesLoop


	; Sprites for counter
	LDA #120
	STA Sprites + 40
	STA Sprites + 43
	STA Sprites + 44
	LDA #0
	STA Sprites + 42
	STA Sprites + 46
	LDA #120 + 8
	STA Sprites + 47

	; First thing to run: NMI
	LDA #1
	STA WaitForNmi

	; NMI enabled
	LDA #%10010000
	STA $2000

	; Game logic
@gameLogic:

	LDA WaitForNmi
	BNE @gameLogicEnd

	; Wait for sprite overflow bit
@waitForNotOverflow:
	LDA $2002
	AND #%00100000
	BNE @waitForNotOverflow
@waitForOverflow:
	LDA $2002
	AND #%00100000
	BEQ @waitForOverflow

	; Update counter on screen
	LDA Counter
	LSR
	LSR
	LSR
	LSR
	STA Sprites + 41
	LDA Counter
	AND #%00001111
	STA Sprites + 45

	INC Counter

	; Wait for NMI
	LDA #1
	STA WaitForNmi

@gameLogicEnd:

	JMP @gameLogic


Nmi:

	PHA
	TXA
	PHA
	TYA
	PHA

	LDA WaitForNmi
	BEQ @end

	LDA #0
	STA WaitForNmi

	; PPUMASK enabled
	LDA #%00011110
	STA $2001

	; Sprite OAMDMA
	LDA #$00
	STA $2003
	LDA #>Sprites
	STA $4014

	; Palette
	LDA $2002
	LDA #$3F
	STA $2006
	LDA #$11
	STA $2006
	LDA #$0D
	STA $2007
	LDA #$05
	STA $2007
	LDA #$02
	STA $2007

	; Scrolling
	LDA #0
	STA $2005
	STA $2005

	; Name table
	LDA #%10010000
	STA $2000

@end:

	PLA
	TAY
	PLA
	TAX
	PLA

	RTI


.segment "VECTORS"

	.word Nmi
	.word Reset
	.word 0


.segment "CHARS"

	.incbin "Graphics.chr"